/*
 *  nvj - NattoView/Java 
 *  (c) 2005-2007 Hidekazu Shiozawa
 *  http://vilab.org
 */

public class NvLayoutSpringFR extends NvLayout {

    int iter = 0;

    public int layout(NvChart chart) {
        dimension = Math.max(16, (int) (Math.sqrt(chart.nodeNumbers()) * 1.5));
        //double k2 = dimension * dimension / chart.nodeNumbers();
        double k2 = 2;
        double k = Math.sqrt(k2);

        float gx = 0, gy = 0;
        for (NvNode v1 : chart.getNodes()) {
            gx += v1.x;
            gy += v1.y;
            v1.fx = v1.fy = 0.0f;
        }
        for (NvNode v1 : chart.getNodes()) {
            for (NvLink link : v1.getRevLinks()) {
                NvNode v2 = link.getSource();
                if (v1 == v2)
                    continue;

                double dx = v1.x - v2.x;
                double dy = v1.y - v2.y;
                double d2 = dx * dx + dy * dy;
                if (d2 < 0.01) {
                    locateNewNode(v2, v1);
                    continue;
                }
                double d = Math.sqrt(d2);
                double L = Math.ceil(Math.sqrt(v1.linkNumbers()))
                        + Math.ceil(Math.sqrt(v2.linkNumbers()));
                L *= (1 + v1.revLinkNumbers());
                v1.fx -= d2 / k * (dx / d) / L;
                v1.fy -= d2 / k * (dy / d) / L;
                v2.fx += d2 / k * (dx / d) / L / (1 + v2.revLinkNumbers()) * 0.1;
                v2.fy += d2 / k * (dy / d) / L / (1 + v2.revLinkNumbers()) * 0.1;
            }
        }
        for (NvNode v1 : chart.getNodes()) {
            for (NvNode v2 : chart.getNodes()) {
                if (v1 == v2)
                    continue;

                double dx = v1.x - v2.x;
                double dy = v1.y - v2.y;
                double d2 = dx * dx + dy * dy;
                if (d2 < 0.01) {
                    locateNewNode(v2, v1);
                    continue;
                }
                double d = Math.sqrt(d2);
                v1.fx += k / d2 * (dx / d);
                v1.fy += k / d2 * (dy / d);
            }
        }
        for (NvNode v1 : chart.getNodes()) {
            v1.xTarget = v1.x + v1.fx / 10.0f - gx / chart.nodeNumbers();
            v1.yTarget = v1.y + v1.fy / 10.0f - gy / chart.nodeNumbers();
            v1.zTarget = v1.z = v1.doi * dimension / 5.0f;
        }
        return dimension;
    }

    public boolean animation(NvChart chart) {
        if (iter % 10 == 0)
            layout(chart);
        return super.animation(chart);
    }
}
