/*
 *  nvj - NattoView/Java 
 *  (c) 2005-2007 Hidekazu Shiozawa
 *  http://vilab.org
 */

public abstract class NvLink {

    protected NvChart chart;
    protected NvNode source, dest;
    protected String label;
    // public Object pickingId;
    protected Object renderingCache = null;

    public NvLink(NvNode source, NvNode dest, String label) {
        chart = source.getChart();
        this.source = source;
        this.dest = dest;
        this.label = label;
    }

    public NvChart getChart() {
        return chart;
    }

    public NvNode getDest() {
        return dest;
    }

    public NvNode getSource() {
        return source;
    }

    public String getLabel() {
        return label;
    }

    public void setLabel(String label) {
        this.label = label;
    }

    public String toString() {
        StringBuffer buf = new StringBuffer();
        buf.append("[Link] ");
        buf.append(getLabel());
        buf.append(": ");
        buf.append(source.getId());
        buf.append(" -> ");
        buf.append(dest.getId());
        return buf.toString();
    }
}
