/*
 *  nvj - NattoView/Java 
 *  (c) 2005-2007 Hidekazu Shiozawa
 *  http://vilab.org
 */

import java.net.URL;
import java.util.*;

public class WebNodeComparator implements Comparator<NvNode> {

    static Stack domainStack(String str) {
        Stack<String> stack = new Stack<String>();
        StringTokenizer st = new StringTokenizer(str, ".");
        while (st.hasMoreTokens())
            stack.push(st.nextToken());
        return stack;
    }

    public int compare(NvNode v1, NvNode v2) {
        URL url1 = (URL)v1.getId();
        URL url2 = (URL)v2.getId();
        int comp, urlcomp;

        urlcomp = url1.toString().compareTo(url2.toString());
        if (urlcomp != 0)
            return urlcomp;

        Stack stack1 = domainStack(url1.getHost());
        Stack stack2 = domainStack(url1.getHost());
        while (!stack1.isEmpty()) {
            if (stack2.isEmpty())
                return 1;
            String str1 = (String)stack1.pop();
            String str2 = (String)stack2.pop();
            comp = str1.compareTo(str2);
            if (comp != 0)
                return comp;
        }
        if (!stack2.isEmpty())
            return -1;

        comp = url1.getPath().compareTo(url2.getPath());
        if (comp != 0)
            return comp;
        return urlcomp;
    }
}
